﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();


			this.SitesDeptsTileViewX.ItemsSource = GenerateItems();
		}

		private List<MyItem> GenerateItems()
		{
			List<MyItem> items = new List<MyItem>();

			for (int i = 1; i < 8; i++)
			{
				MyItem item = new MyItem() { Header = String.Format("Header {0}", i) };
				items.Add(item);
			}

			return items;
		}

		private void RadTileView_TileStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			RadTileViewItem item = e.Source as RadTileViewItem;

			if (item != null)
			{
				List<RadFluidContentControl> mylist = GetChildren<RadFluidContentControl>(item);
				if (mylist.Count > 0 && mylist[0] != null)
				{
					RadFluidContentControl contentControl = mylist[0];
					switch (item.TileState)
					{
						case TileViewItemState.Maximized:
							contentControl.State = FluidContentControlState.Large;
							break;
						case TileViewItemState.Minimized:
							contentControl.State = FluidContentControlState.Small;
							break;
						case TileViewItemState.Restored:
							contentControl.State = FluidContentControlState.Normal;
							break;
					}
				}
			}
		}

		public List<T> GetChildren<T>(DependencyObject parent) where T : FrameworkElement
		{
			List<T> collection = new List<T>();

			if (parent != null)
			{
				int count = VisualTreeHelper.GetChildrenCount(parent);
				for (int i = 0; i < count; i++)
				{
					DependencyObject obj = VisualTreeHelper.GetChild(parent, i);
					if (obj.GetType() == typeof(T))
					{
						collection.Add((T)obj);
					}
					if (VisualTreeHelper.GetChildrenCount(obj) > 0)
					{
						foreach (T newElement in GetChildren<T>(obj))
						{
							collection.Add(newElement);
						}
					}
				}
			}
			else
			{
				return null;
			}

			return collection;
		}
	}

	public class MyItem
	{
		public string Header { get; set; }
	}
}
